package de.fhws.robotxkey.activities;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.TextView;
import de.fhws.robotxkey.R;
import de.fhws.robotxkey.connection.Connection;

public class ActivityConnect extends Activity {
	public Thread threadConnect = null;
	
	public Thread threadCorrect = null;
	
	public BaseAdapter baseadapterBluetooth = null;
	
	public ListView listviewBluetooth = null;
	
	public ProgressBar progressbarLoading = null;
	
	public Button buttonCorrect = null;
	
	public Button buttonRetry = null;
	
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		this.setContentView(R.layout.activityconnect);
		
		{
			this.threadConnect = null;
		}
		
		{
			this.threadCorrect = null;
		}
		
		{
			this.baseadapterBluetooth = new BaseAdapter() {
				public int getCount() {
					return Math.min(Connection.obtain().strConnectTime.size(), Connection.obtain().strConnectMessage.size());
				}
				
				public Object getItem(int intIndex) {
					return null;
				}
				
				public long getItemId(int intIndex) {
					return intIndex;
				}
				
				public View getView(int intIndex, View viewHandle, ViewGroup viewgroupHandle) {
					if (viewHandle == null) {
						viewHandle = ActivityConnect.this.getLayoutInflater().inflate(R.layout.activityconnectlistview, viewgroupHandle, false);
					}
					
					TextView textviewName = (TextView) (viewHandle.findViewById(R.id.textviewConnectListviewTime));
					TextView textviewMac = (TextView) (viewHandle.findViewById(R.id.textviewConnectListviewMessage));
					
					textviewName.setText(Connection.obtain().strConnectTime.get(intIndex));
					textviewMac.setText(Connection.obtain().strConnectMessage.get(intIndex));
					
					return viewHandle;
				}
			};
		}
		
		{
			this.listviewBluetooth = (ListView) (this.findViewById(R.id.listviewConnectBluetooth));
			
			{
				this.listviewBluetooth.setDividerHeight(0);
				
				this.listviewBluetooth.setOnItemClickListener(new OnItemClickListener() {
					public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
						
					}
				});
				
				this.listviewBluetooth.setAdapter(this.baseadapterBluetooth);
			}
		}
		
		{
			this.progressbarLoading = (ProgressBar) (this.findViewById(R.id.progressbarConnectLoading));
		}
		
		{
			this.buttonCorrect = (Button) (this.findViewById(R.id.buttonConnectCorrect));
			
			{
				this.buttonCorrect.setOnClickListener(new OnClickListener() {
					public void onClick(View arg0) {
						{
							ActivityConnect.this.buttonCorrect.setVisibility(View.GONE);
						}
						
						{
							ActivityConnect.this.threadCorrect = new ThreadCorrect(ActivityConnect.this);
							
							ActivityConnect.this.threadCorrect.start();
						}
					}
				});
			}
		}
		
		{
			this.buttonRetry = (Button) (this.findViewById(R.id.buttonConnectRetry));
			
			{
				this.buttonRetry.setOnClickListener(new OnClickListener() {
					public void onClick(View arg0) {
						{
							ActivityConnect.this.buttonRetry.setVisibility(View.GONE);
						}
						
						{
							ActivityConnect.this.threadConnect = new ThreadConnect(ActivityConnect.this);
							
							ActivityConnect.this.threadConnect.start();
						}
					}
				});
			}
		}
	}
	
	public void onPause() {
		super.onPause();
		
		if (this.threadConnect != null) {
			this.threadConnect.interrupt();
			
			this.threadConnect = null;
		}
		
		if (this.threadCorrect != null) {
			this.threadCorrect.interrupt();
			
			this.threadCorrect = null;
		}
	}
	
	public void onResume() {
		super.onResume();
		
		{
			this.threadConnect = new ThreadConnect(this);
			
			this.threadConnect.start();
		}
		
		{
			this.threadCorrect = null;
		}
	}
	
	public static class ThreadConnect extends Thread {
		public ActivityConnect activityconnectHandle = null;
		
		public ThreadConnect(ActivityConnect activityconnectHandle) {
			this.activityconnectHandle = activityconnectHandle;
		}
		
		public boolean boolCorrect = false;
		
		public void run() {
			{
				if (this.isInterrupted() == true) {
					return;
				}
				
				this.activityconnectHandle.runOnUiThread(new Runnable() {
					public void run() {
						{
							ThreadConnect.this.activityconnectHandle.progressbarLoading.setVisibility(View.VISIBLE);
						}
						
						{
							ThreadConnect.this.activityconnectHandle.buttonCorrect.setVisibility(View.GONE);
						}
						
						{
							ThreadConnect.this.activityconnectHandle.buttonRetry.setVisibility(View.GONE);
						}
					}
				});
			}
			
			try {
				{
					Connection.obtain().strConnectTime.clear();
					
					Connection.obtain().strConnectMessage.clear();
				}
				
				this.activityconnectHandle.runOnUiThread(new Runnable() {
					public void run() {
						Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
						Connection.obtain().strConnectMessage.add(ThreadConnect.this.activityconnectHandle.getString(R.string.ActivityConnect_Concheck));
						
						ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
						ThreadConnect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
					}
				});
				
				{
					Connection.obtain().disconnect();
				}
				
				{
					Thread.sleep(1000);
				}
				
				{
					Connection.obtain().connect();
				}
				
				{
					Thread.sleep(500);
				}
				
				if (Connection.obtain().boolValid == true) {
					this.activityconnectHandle.runOnUiThread(new Runnable() {
						public void run() {
							Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
							Connection.obtain().strConnectMessage.add(ThreadConnect.this.activityconnectHandle.getString(R.string.ActivityConnect_Convalid));
							
							ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
							ThreadConnect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
						}
					});
					
				} else if (Connection.obtain().boolValid == false) {
					this.activityconnectHandle.runOnUiThread(new Runnable() {
						public void run() {
							Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
							Connection.obtain().strConnectMessage.add(ThreadConnect.this.activityconnectHandle.getString(R.string.ActivityConnect_Conerror));
							
							ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
							ThreadConnect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
						}
					});
					
					{
						throw new Exception();
					}
					
				}
				
				this.activityconnectHandle.runOnUiThread(new Runnable() {
					public void run() {
						Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
						Connection.obtain().strConnectMessage.add(ThreadConnect.this.activityconnectHandle.getString(R.string.ActivityConnect_Ackcheck));
						
						ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
						ThreadConnect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
					}
				});
				
				{
					Connection.obtain().getConnack();
				}
				
				{
					Thread.sleep(500);
				}
				
				if (Connection.obtain().boolValid == true) {
					this.activityconnectHandle.runOnUiThread(new Runnable() {
						public void run() {
							Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
							Connection.obtain().strConnectMessage.add(ThreadConnect.this.activityconnectHandle.getString(R.string.ActivityConnect_Ackvalid));
							
							ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
							ThreadConnect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
						}
					});
					
					{
						this.boolCorrect = false;
					}
					
				} else if (Connection.obtain().boolValid == false) {
					this.activityconnectHandle.runOnUiThread(new Runnable() {
						public void run() {
							Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
							Connection.obtain().strConnectMessage.add(ThreadConnect.this.activityconnectHandle.getString(R.string.ActivityConnect_Ackerror));
							
							ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
							ThreadConnect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
						}
					});
					
					{
						this.boolCorrect = true;
					}
					
					{
						throw new Exception();
					}
					
				}
				
				this.activityconnectHandle.runOnUiThread(new Runnable() {
					public void run() {
						Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
						Connection.obtain().strConnectMessage.add(ThreadConnect.this.activityconnectHandle.getString(R.string.ActivityConnect_Echockeck));
						
						ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
						ThreadConnect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
					}
				});
				
				{
					Connection.obtain().getEchocheck();
				}
				
				{
					Thread.sleep(500);
				}
				
				if (Connection.obtain().boolValid == true) {
					this.activityconnectHandle.runOnUiThread(new Runnable() {
						public void run() {
							Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
							Connection.obtain().strConnectMessage.add(ThreadConnect.this.activityconnectHandle.getString(R.string.ActivityConnect_Echovalid));
							
							ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
							ThreadConnect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
						}
					});
					
				} else if (Connection.obtain().boolValid == false) {
					this.activityconnectHandle.runOnUiThread(new Runnable() {
						public void run() {
							Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
							Connection.obtain().strConnectMessage.add(ThreadConnect.this.activityconnectHandle.getString(R.string.ActivityConnect_Echoerror));
							
							ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
							ThreadConnect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
						}
					});
					
					{
						throw new Exception();
					}
					
				}
				
				this.activityconnectHandle.runOnUiThread(new Runnable() {
					public void run() {
						Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
						Connection.obtain().strConnectMessage.add(ThreadConnect.this.activityconnectHandle.getString(R.string.ActivityConnect_Success));
						
						ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
						ThreadConnect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadConnect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
					}
				});
				
				{
					Thread.sleep(500);
				}
				
				{
					Intent intentHandle = new Intent(this.activityconnectHandle, ActivityController.class);
					
					this.activityconnectHandle.startActivity(intentHandle);
				}
				
				{
					this.activityconnectHandle.finish();
				}
			} catch (Exception e) {
				{
					// Connection.obtain().disconnect();
				}
			}
			
			{
				if (this.isInterrupted() == true) {
					return;
				}
				
				this.activityconnectHandle.runOnUiThread(new Runnable() {
					public void run() {
						{
							ThreadConnect.this.activityconnectHandle.progressbarLoading.setVisibility(View.GONE);
						}
						
						if (ThreadConnect.this.boolCorrect == true) {
							ThreadConnect.this.activityconnectHandle.buttonCorrect.setVisibility(View.VISIBLE);
							
						} else if (ThreadConnect.this.boolCorrect == false) {
							ThreadConnect.this.activityconnectHandle.buttonCorrect.setVisibility(View.GONE);
							
						}
						
						{
							ThreadConnect.this.activityconnectHandle.buttonRetry.setVisibility(View.VISIBLE);
						}
					}
				});
			}
		}
	}
	
	public static class ThreadCorrect extends Thread {
		public ActivityConnect activityconnectHandle = null;
		
		public ThreadCorrect(ActivityConnect activityconnectHandle) {
			this.activityconnectHandle = activityconnectHandle;
		}
		
		public void run() {
			{
				if (this.isInterrupted() == true) {
					return;
				}
				
				this.activityconnectHandle.runOnUiThread(new Runnable() {
					public void run() {
						{
							ThreadCorrect.this.activityconnectHandle.progressbarLoading.setVisibility(View.VISIBLE);
						}
						
						{
							ThreadCorrect.this.activityconnectHandle.buttonCorrect.setVisibility(View.GONE);
						}
						
						{
							ThreadCorrect.this.activityconnectHandle.buttonRetry.setVisibility(View.GONE);
						}
					}
				});
			}
			
			try {
				{
					Connection.obtain().strConnectTime.clear();
					
					Connection.obtain().strConnectMessage.clear();
				}
				
				this.activityconnectHandle.runOnUiThread(new Runnable() {
					public void run() {
						Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
						Connection.obtain().strConnectMessage.add(ThreadCorrect.this.activityconnectHandle.getString(R.string.ActivityConnect_Corrcheck));
						
						ThreadCorrect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
						ThreadCorrect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadCorrect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
					}
				});
				
				{
					Connection.obtain().getCorrect();
				}
				
				if (Connection.obtain().boolValid == true) {
					this.activityconnectHandle.runOnUiThread(new Runnable() {
						public void run() {
							Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
							Connection.obtain().strConnectMessage.add(ThreadCorrect.this.activityconnectHandle.getString(R.string.ActivityConnect_Corrvalid));
							
							ThreadCorrect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
							ThreadCorrect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadCorrect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
						}
					});
					
				} else if (Connection.obtain().boolValid == false) {
					this.activityconnectHandle.runOnUiThread(new Runnable() {
						public void run() {
							Connection.obtain().strConnectTime.add(new SimpleDateFormat("HH:mm:ss", Locale.US).format(new Date().getTime()));
							Connection.obtain().strConnectMessage.add(ThreadCorrect.this.activityconnectHandle.getString(R.string.ActivityConnect_Correrror));
							
							ThreadCorrect.this.activityconnectHandle.baseadapterBluetooth.notifyDataSetChanged();
							ThreadCorrect.this.activityconnectHandle.listviewBluetooth.setSelection(ThreadCorrect.this.activityconnectHandle.baseadapterBluetooth.getCount() - 1);
						}
					});
					
					{
						throw new Exception();
					}
					
				}
			} catch (Exception e) {
				{
					// Connection.obtain().disconnect();
				}
			}
			
			{
				if (this.isInterrupted() == true) {
					return;
				}
				
				this.activityconnectHandle.runOnUiThread(new Runnable() {
					public void run() {
						{
							ThreadCorrect.this.activityconnectHandle.progressbarLoading.setVisibility(View.GONE);
						}
						
						{
							ThreadCorrect.this.activityconnectHandle.buttonCorrect.setVisibility(View.GONE);
						}
						
						{
							ThreadCorrect.this.activityconnectHandle.buttonRetry.setVisibility(View.VISIBLE);
						}
					}
				});
			}
		}
	}
}
