package de.fhws.robotxkey.activities;

import java.util.Vector;

import android.app.Activity;
import android.os.Bundle;
import android.widget.Button;
import android.widget.TextView;
import android.widget.Toast;
import de.fhws.robotxkey.R;
import de.fhws.robotxkey.connection.Connection;

public class ActivityController extends Activity {
	public Thread threadBackground = null;
	
	public Vector<Button> buttonHandle = new Vector<Button>();
	
	public TextView textviewCounterpart = null;
	
	public Toast toastError = null;
	
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		this.setContentView(R.layout.activitycontroller);
		
		{
			this.threadBackground = null;
		}
		
		{
			this.buttonHandle.add((Button) (this.findViewById(R.id.buttonController1)));
			this.buttonHandle.add((Button) (this.findViewById(R.id.buttonController2)));
			this.buttonHandle.add((Button) (this.findViewById(R.id.buttonController3)));
			this.buttonHandle.add((Button) (this.findViewById(R.id.buttonController4)));
			this.buttonHandle.add((Button) (this.findViewById(R.id.buttonController5)));
			this.buttonHandle.add((Button) (this.findViewById(R.id.buttonController6)));
			this.buttonHandle.add((Button) (this.findViewById(R.id.buttonController7)));
			this.buttonHandle.add((Button) (this.findViewById(R.id.buttonController8)));
			this.buttonHandle.add((Button) (this.findViewById(R.id.buttonController9)));
		}
		
		{
			this.textviewCounterpart = (TextView) (this.findViewById(R.id.textviewControllerCounterpart));
			
			{
				this.textviewCounterpart.setText(Connection.obtain().strConnectName);
			}
		}
		
		{
			this.toastError = Toast.makeText(ActivityController.this, ActivityController.this.getString(R.string.ActivityController_Error), Toast.LENGTH_SHORT);
		}
	}
	
	public void onPause() {
		super.onPause();
		
		{
			this.threadBackground.interrupt();
		}
		
		{
			this.toastError.cancel();
		}
	}
	
	public void onResume() {
		super.onResume();
		
		{
			this.threadBackground = new Thread() {
				public void run() {
					try {
						do {
							{
								int[] intButtons = new int[9];
								
								for (int intFor1 = 0; intFor1 < ActivityController.this.buttonHandle.size(); intFor1 += 1) {
									Button buttonHandle = ActivityController.this.buttonHandle.get(intFor1);
									
									if (buttonHandle.isPressed() == true) {
										intButtons[intFor1] = 1;
										
									} else if (buttonHandle.isPressed() == false) {
										intButtons[intFor1] = 0;
										
									}
								}
								
								Connection.obtain().submit(intButtons);
							}
							
							{
								if (this.isInterrupted() == true) {
									return;
								}
								
								if (Connection.obtain().boolValid == false) {
									ActivityController.this.runOnUiThread(new Runnable() {
										public void run() {
											ActivityController.this.toastError.show();
										}
									});
								}
							}
							
							{
								Thread.sleep(10);
							}
						} while (true);
					} catch (Exception e) {
						// e.printStackTrace();
					}
				}
			};
			
			this.threadBackground.start();
		}
	}
}
