package de.fhws.robotxkey.activities;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.BaseAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.TextView;
import android.widget.Toast;
import de.fhws.robotxkey.R;
import de.fhws.robotxkey.connection.Connection;

public class ActivityMain extends Activity {
	public BaseAdapter baseadapterBluetooth = null;
	
	public ListView listviewBluetooth = null;
	
	public Button buttonPair = null;
	
	public Button buttonRefresh = null;
	
	public Toast toastRefreshed = null;
	
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		
		this.setContentView(R.layout.activitymain);
		
		{
			Connection.obtain().enable();
			
			Connection.obtain().refresh();
		}
		
		{
			this.baseadapterBluetooth = new BaseAdapter() {
				public int getCount() {
					return Math.min(Connection.obtain().strRefreshName.size(), Connection.obtain().strRefreshMac.size());
				}
				
				public Object getItem(int intIndex) {
					return null;
				}
				
				public long getItemId(int intIndex) {
					return intIndex;
				}
				
				public View getView(int intIndex, View viewHandle, ViewGroup viewgroupHandle) {
					if (viewHandle == null) {
						viewHandle = ActivityMain.this.getLayoutInflater().inflate(R.layout.activitymainlistview, viewgroupHandle, false);
					}
					
					TextView textviewName = (TextView) (viewHandle.findViewById(R.id.textviewMainListviewName));
					TextView textviewMac = (TextView) (viewHandle.findViewById(R.id.textviewMainListviewMac));
					
					textviewName.setText(Connection.obtain().strRefreshName.get(intIndex));
					textviewMac.setText(Connection.obtain().strRefreshMac.get(intIndex));
					
					return viewHandle;
				}
			};
		}
		
		{
			this.listviewBluetooth = (ListView) (this.findViewById(R.id.listviewMainBluetooth));
			
			{
				this.listviewBluetooth.setDividerHeight(0);
				
				this.listviewBluetooth.setOnItemClickListener(new OnItemClickListener() {
					public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
						{
							Connection.obtain().strConnectName = Connection.obtain().strRefreshName.get(arg2);
							
							Connection.obtain().strConnectMac = Connection.obtain().strRefreshMac.get(arg2);
						}
						
						{
							Intent intentHandle = new Intent(ActivityMain.this, ActivityConnect.class);
							
							ActivityMain.this.startActivity(intentHandle);
						}
					}
				});
				
				this.listviewBluetooth.setAdapter(this.baseadapterBluetooth);
			}
		}
		
		{
			this.buttonPair = (Button) (this.findViewById(R.id.buttonMainPair));
			
			{
				this.buttonPair.setOnClickListener(new OnClickListener() {
					public void onClick(View arg0) {
						{
							Intent intentHandle = new Intent(android.provider.Settings.ACTION_BLUETOOTH_SETTINGS);
							
							ActivityMain.this.startActivity(intentHandle);
						}
					}
				});
			}
		}
		
		{
			this.buttonRefresh = (Button) (this.findViewById(R.id.buttonMainRefresh));
			
			{
				this.buttonRefresh.setOnClickListener(new OnClickListener() {
					public void onClick(View arg0) {
						{
							Connection.obtain().enable();
							
							Connection.obtain().refresh();
						}
						
						{
							ActivityMain.this.baseadapterBluetooth.notifyDataSetChanged();
						}
						
						{
							ActivityMain.this.toastRefreshed.show();
						}
					}
				});
			}
		}
		
		{
			this.toastRefreshed = Toast.makeText(ActivityMain.this, ActivityMain.this.getString(R.string.ActivityMain_Refreshed), Toast.LENGTH_SHORT);
		}
	}
	
	public void onPause() {
		super.onPause();
		
		{
			this.toastRefreshed.cancel();
		}
	}
}