package de.fhws.robotxkey.connection;

import java.util.Arrays;
import java.util.Iterator;
import java.util.Vector;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import de.fhws.robotxkey.txc.TxcConnection;
import de.fhws.robotxkey.txc.TxcProtocol;

public class Connection {
	public static Connection connectionHandle = null;
	
	public static void init() {
		if (Connection.connectionHandle == null) {
			Connection.connectionHandle = new Connection();
		}
	}
	
	public static void dispel() {
		if (Connection.connectionHandle != null) {
			Connection.connectionHandle.finalize();
			
			Connection.connectionHandle = null;
		}
	}
	
	public static Connection obtain() {
		Connection.init();
		
		return Connection.connectionHandle;
	}
	
	public boolean boolValid = false;
	
	public TxcConnection txcconnectionHandle = null;
	public TxcProtocol txcprotocolHandle = null;
	
	public Vector<String> strRefreshName = new Vector<String>();
	public Vector<String> strRefreshMac = new Vector<String>();
	
	public String strConnectName = "";
	public String strConnectMac = "";
	
	public Vector<String> strConnectTime = new Vector<String>();
	public Vector<String> strConnectMessage = new Vector<String>();
	
	public Connection() {
		{
			this.boolValid = false;
		}
		
		{
			this.txcconnectionHandle = new TxcConnection();
			
			this.txcprotocolHandle = new TxcProtocol();
		}
		
		{
			this.strRefreshName.clear();
			
			this.strRefreshMac.clear();
		}
		
		{
			this.strConnectName = "";
			
			this.strConnectMac = "";
		}
		
		{
			this.strConnectTime.clear();
			
			this.strConnectMessage.clear();
		}
	}
	
	public void finalize() {
		{
			this.boolValid = false;
		}
		
		{
			this.txcconnectionHandle = null;
			
			this.txcprotocolHandle = null;
		}
		
		{
			this.strRefreshName.clear();
			
			this.strRefreshMac.clear();
		}
		
		{
			this.strConnectName = "";
			
			this.strConnectMac = "";
		}
		
		{
			this.strConnectTime.clear();
			
			this.strConnectMessage.clear();
		}
	}
	
	public void enable() {
		{
			BluetoothAdapter.getDefaultAdapter().enable();
		}
	}
	
	public void refresh() {
		{
			this.strRefreshName.clear();
			
			this.strRefreshMac.clear();
		}
		
		{
			Iterator<BluetoothDevice> iteratorHandle = BluetoothAdapter.getDefaultAdapter().getBondedDevices().iterator();
			
			do {
				if (iteratorHandle.hasNext() == false) {
					break;
				}
				
				{
					BluetoothDevice bluetoothdeviceHandle = iteratorHandle.next();
					
					this.strRefreshName.add(bluetoothdeviceHandle.getName());
					this.strRefreshMac.add(bluetoothdeviceHandle.getAddress());
				}
			} while (true);
		}
	}
	
	public void connect() {
		{
			this.txcconnectionHandle.connect(this.strConnectMac);
		}
		
		{
			if (this.txcconnectionHandle.boolValid == true) {
				this.boolValid = true;
				
			} else if (this.txcconnectionHandle.boolValid == false) {
				this.boolValid = false;
				
			}
		}
	}
	
	public void disconnect() {
		{
			this.txcconnectionHandle.disconnect();
		}
		
		{
			if (this.txcconnectionHandle.boolValid == true) {
				this.boolValid = true;
				
			} else if (this.txcconnectionHandle.boolValid == false) {
				this.boolValid = false;
				
			}
		}
	}
	
	public void getConnack() {
		{
			this.txcprotocolHandle.getConnack(this.txcconnectionHandle.inputstreamHandle);
		}
		
		{
			if (this.txcprotocolHandle.boolValid == true) {
				this.boolValid = true;
				
			} else if (this.txcprotocolHandle.boolValid == false) {
				this.boolValid = false;
				
			}
		}
	}
	
	public void getEchocheck() {
		{
			this.txcprotocolHandle.getEchocheck(this.txcconnectionHandle.inputstreamHandle, this.txcconnectionHandle.outputstreamHandle);
		}
		
		{
			if (this.txcprotocolHandle.boolValid == true) {
				this.boolValid = true;
				
			} else if (this.txcprotocolHandle.boolValid == false) {
				this.boolValid = false;
				
			}
		}
	}
	
	public void getCorrect() {
		{
			this.txcprotocolHandle.getCorrect(this.txcconnectionHandle.inputstreamHandle, this.txcconnectionHandle.outputstreamHandle);
		}
		
		{
			if (this.txcprotocolHandle.boolValid == true) {
				this.boolValid = true;
				
			} else if (this.txcprotocolHandle.boolValid == false) {
				this.boolValid = false;
				
			}
		}
	}
	
	public void submit(int[] intButtons) {
		try {
			{
				this.boolValid = false;
			}
			
			{
				this.txcprotocolHandle.intData = Arrays.copyOf(intButtons, intButtons.length);
				
				this.txcprotocolHandle.write(this.txcconnectionHandle.outputstreamHandle);
			}
			
			if (this.txcprotocolHandle.boolValid == false) {
				throw new Exception();
			}
			
			{
				this.txcprotocolHandle.read(this.txcconnectionHandle.inputstreamHandle, 1000);
			}
			
			if (this.txcprotocolHandle.boolValid == false) {
				throw new Exception();
			}
			
			if (Arrays.equals(this.txcprotocolHandle.intData, intButtons) == false) {
				throw new Exception();
			}
			
			{
				this.boolValid = true;
			}
		} catch (Exception e) {
			// e.printStackTrace();
		}
	}
}
